/* 
 * Birdstep Wireless DB
 *
 * Copyright (C) 1999, 2000 by Birdstep Technology AS 
 * All rights reserved.
 *
 * xml.h - XML support functions.
 *
 * $Id: xml.h,v 1.2 2000/06/23 13:09:25 mlj Exp $
 *
 */

#ifndef XML_H
#define XML_H

#include "bde.h"

/* Shadowed XML base types. */
enum {
    /* BYTE shadow. */
    IBBASE_TYPE_XML_ENTITY_TYPE     = 0x80,

    /* DBADDR shadows. */
    IBBASE_TYPE_XML_RETURN,

    IBBASE_TYPE_XML_DOCUMENT,
    IBBASE_TYPE_XML_NOTATION,
    IBBASE_TYPE_XML_ENTITY,
    IBBASE_TYPE_XML_ENTITY_NOTATION,
    IBBASE_TYPE_XML_ELEMENT,
    IBBASE_TYPE_XML_ATTRIBUTE,
    IBBASE_TYPE_XML_ATTRIBUTE_NS,
    IBBASE_TYPE_XML_NAMESPACE,

    /* UNI shadows. */
    IBBASE_TYPE_XML_ENTITY_NAME,
    IBBASE_TYPE_XML_ENTITY_SYSID,
    IBBASE_TYPE_XML_ENTITY_PUBID,
    IBBASE_TYPE_XML_ENTITY_BASEURI,
    IBBASE_TYPE_XML_NOTATION_NAME,
    IBBASE_TYPE_XML_NOTATION_SYSID,
    IBBASE_TYPE_XML_NOTATION_PUBID,
    IBBASE_TYPE_XML_NOTATION_BASEURI,
    IBBASE_TYPE_XML_COMMENT,
    IBBASE_TYPE_XML_ATTRIBUTE_LOCAL,
    IBBASE_TYPE_XML_ATTRIBUTE_VALUE,
    IBBASE_TYPE_XML_PI,
    IBBASE_TYPE_XML_PI_TARGET,
    IBBASE_TYPE_XML_PI_CONTENT,
    IBBASE_TYPE_XML_SKIPPED,
    IBBASE_TYPE_XML_CHARACTER,
    IBBASE_TYPE_XML_NAMESPACE_PREFIX,
    IBBASE_TYPE_XML_NAMESPACE_URI,
    IBBASE_TYPE_XML_NAMESPACE_VALUE,

    IBBASE_TYPE_SHADOW_MAX
};

typedef struct ibxmldct *ibxmldcthandle;

/* Prototypes. */
ibret IBCALL IBXMLAppendPointerPair(ibcursorhandle cursor, ibutype u1,
                                    ibutype u2, ibbtype b1, 
                                    ibdbaddr *parent,
                                    ibdbaddr *child);

#endif /* XML_H */

/* 
   Local Variables:
   mode:c
   indent-tabs-mode:nil
   c-basic-offset:4
   End:
*/
