//
// BDE demonstration application
//
// Copyright (C) 1999, 2000 by Birdstep Technology AS
//
// bdeappw32Doc.cpp
//
// implementation of the CBdeappw32Doc class
//
// Written by Henrik Solgaard
//

#include "stdafx.h"
#include "bdeappw32.h"
#include "bdeappw32Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32Doc

IMPLEMENT_DYNCREATE(CBdeappw32Doc, CDocument)

BEGIN_MESSAGE_MAP(CBdeappw32Doc, CDocument)
	//{{AFX_MSG_MAP(CBdeappw32Doc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32Doc construction/destruction

CBdeappw32Doc::CBdeappw32Doc()
{
	// TODO: add one-time construction code here
	database = NULL;
	dict = NULL;

}

CBdeappw32Doc::~CBdeappw32Doc()
{
	if (dict)
		IBDctDestroy(dict);
	if (database)
		IBDbClose(database);
}

BOOL CBdeappw32Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CBdeappw32Doc serialization

void CBdeappw32Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32Doc diagnostics

#ifdef _DEBUG
void CBdeappw32Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBdeappw32Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32Doc commands

BOOL CBdeappw32Doc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!CDocument::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here
	
	return TRUE;
}

int CBdeappw32Doc::OpenDatabaseFile(LPCTSTR str)
{
    struct ibdbparams dbparams;

    memset(&dbparams, 0, sizeof(struct ibdbparams));
    dbparams.bufnum = 10;
    dbparams.flags = IBDBFLAG_OPEN_ALWAYS_RO; // Makes it read-only
    dbparams.driver= IBDB_DRIVER_DEFAULT; // Get the appropriate driver

    error_code = IBDbCreate(&database, NULL, str, &dbparams);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBDctCreate(&dict, database);
	if (error_code != IBERR_NONE)
		return error_code;
	return IBERR_NONE;
}

// SearchForDataType searches the database for a string.
// It only examines fields of the given type.
ibret CBdeappw32Doc::SearchForDataType(const char *str, ibdcttypehandle datatype){
	// Create query
	error_code = IBQueryCreate(&query, database);
	if (error_code != IBERR_NONE)
		return error_code;
	// Set query parameters
	error_code = IBQueryGetParams(query, &queryparams);
	if (error_code != IBERR_NONE){
		IBQueryDestroy(query, IBQUERY_DESTROY_NON_RECURSIVE);
		return error_code;
	}
	queryparams->type = IBQUERY_NODE_TYPE_UNOP;
	queryparams->data.criterium.type = IBQUERY_CRITERIUM_TYPE_EXACT;
	queryparams->data.criterium.level = IBQUERY_CRITERIUM_LEVEL_RECORD;
	queryparams->data.criterium.op = IBSET_UNOP_NONE;
	queryparams->data.criterium.data1 = (void *)str;
	queryparams->data.criterium.enc1 = IBENC_DEFAULT;
	queryparams->data.criterium.data_type = datatype;
	// Execute query
	error_code = IBQueryExecute(query, &result);
	if (error_code != IBERR_NONE){
		IBQueryDestroy(query, IBQUERY_DESTROY_NON_RECURSIVE);
		return error_code;
	}
	// Destroy query
	error_code = IBQueryDestroy(query, IBQUERY_DESTROY_NON_RECURSIVE);
	if (error_code != IBERR_NONE)
		return error_code;
	return IBERR_NONE;
}

// SearchFirstName searches for a given first name and inserts the resulting
// records into the application's list view.
int CBdeappw32Doc::SearchFirstName(const char *str, CListCtrl &lc)
{
	CString item_text;
	ibdcttypehandle type_handle;
	error_code = IBDctLookupName(dict, "Firstname", &type_handle, IBENC_US_ASCII);
	if (error_code != IBERR_NONE)
		return error_code;
	// This is a simple hack that is required because the dictionary lookup
	// function doesn't support XML types. The handle that is returned by
	// IBDctLookupName contains the base type IBBASE_TYPE_NONE which is useless
	// for searching. By adding IBBASE_TYPE_XML_CHARACTER to the handle, we
	// change the type of the handle to the XML character type. This is
	// possible because the base type is stored in the least significant bits
	// of the handle. The IBDCT_MAKE_TYPE_HANDLE macro in the file bde.h shows
	// the structure of the handle.
	type_handle = type_handle + IBBASE_TYPE_XML_CHARACTER;
	// Search for first names matching str
	error_code = SearchForDataType(str, type_handle);
	if (error_code != IBERR_NONE)
		return error_code;
	// Create result list
	error_code = IBResListCreate(&result_list, result, 0, 0);
	if (error_code != IBERR_NONE)
		return error_code;
	// Destroy result
	error_code = IBResDestroy(result);
	if (error_code != IBERR_NONE)
		return error_code;
	// Get number of hits
	IBResListGetSize(result_list, &records_found);
	// Create a cursor to use for lookups
	error_code = IBCursorCreate(&cursor, database);
	if (error_code != IBERR_NONE)
		return error_code;
	// Delete contents of the application window
	lc.DeleteAllItems();
	// Traverse the resultlist and insert all available information for each person
	// into the application window's list view
	for (rl_index = 0; rl_index < records_found; rl_index++){
		// Place the cursor at hit number (rl_index)
		error_code = IBResListGetItem(result_list, cursor, rl_index);
		if (error_code != IBERR_NONE)
			return error_code;
		// Go to the top of the structure for the current hit
		GotoParent(cursor, 1);
		// Get the first attribute and insert it
		GetStringFromField(cursor, 2, item_text);
		lc.InsertItem(rl_index, item_text);
		// Get the rest of the attributes on the first level
		for (int j=1; j<=8; j++){
			GetStringFromField(cursor, 2*j+2, item_text);
			lc.SetItemText(rl_index, j, item_text);
		}
		// Get the sttributes inside the address tag
		for (j=1; j<=6; j++){
			GetStringFromAddressField(cursor, 2*j-1, item_text);
			lc.SetItemText(rl_index, j+8, item_text);
		}
	}
	error_code = IBCursorDestroy(cursor);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBResListDestroy(result_list);
	if (error_code != IBERR_NONE)
		return error_code;
	return IBERR_NONE;
}

// SearchLastName searches for a given last name and inserts the resulting
// records into the application's list view.
int CBdeappw32Doc::SearchLastName(const char *str, CListCtrl &lc)
{
	CString item_text;
	ibdcttypehandle type_handle;
	error_code = IBDctLookupName(dict, "Lastname", &type_handle, IBENC_US_ASCII);
	if (error_code != IBERR_NONE)
		return error_code;
	type_handle = type_handle + IBBASE_TYPE_XML_CHARACTER;
	error_code = SearchForDataType(str, type_handle);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBResListCreate(&result_list, result, 0, 0);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBResDestroy(result);
	if (error_code != IBERR_NONE)
		return error_code;
	IBResListGetSize(result_list, &records_found);
	error_code = IBCursorCreate(&cursor, database);
	if (error_code != IBERR_NONE)
		return error_code;
	lc.DeleteAllItems();
	for (rl_index = 0; rl_index < records_found; rl_index++){
		error_code = IBResListGetItem(result_list, cursor, rl_index);
		if (error_code != IBERR_NONE)
			return error_code;
		GotoParent(cursor, 1);
		GetStringFromField(cursor, 2, item_text);
		lc.InsertItem(rl_index, item_text);
		for (int j=1; j<=8; j++){
			GetStringFromField(cursor, 2*j+2, item_text);
			lc.SetItemText(rl_index, j, item_text);
		}
		for (j=1; j<=6; j++){
			GetStringFromAddressField(cursor, 2*j-1, item_text);
			lc.SetItemText(rl_index, j+8, item_text);
		}
	}
	error_code = IBCursorDestroy(cursor);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBResListDestroy(result_list);
	if (error_code != IBERR_NONE)
		return error_code;
	return IBERR_NONE;
}

// SearchCountry searches for a given country and inserts the resulting
// records into the application's list view.
int CBdeappw32Doc::SearchCountry(const char *str, CListCtrl &lc)
{
	CString item_text;
	ibdcttypehandle type_handle;
	error_code = IBDctLookupName(dict, "Country", &type_handle, IBENC_US_ASCII);
	if (error_code != IBERR_NONE)
		return error_code;
	type_handle = type_handle + IBBASE_TYPE_XML_CHARACTER;
	error_code = SearchForDataType(str, type_handle);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBResListCreate(&result_list, result, 0, 0);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBResDestroy(result);
	if (error_code != IBERR_NONE)
		return error_code;
	IBResListGetSize(result_list, &records_found);
	error_code = IBCursorCreate(&cursor, database);
	if (error_code != IBERR_NONE)
		return error_code;
	lc.DeleteAllItems();
	for (rl_index = 0; rl_index < records_found; rl_index++){
		error_code = IBResListGetItem(result_list, cursor, rl_index);
		if (error_code != IBERR_NONE)
			return error_code;
		GotoParent(cursor, 2); // Go two levels up because the country tag is inside the
		                       // address tag in the XML document.
		GetStringFromField(cursor, 2, item_text);
		lc.InsertItem(rl_index, item_text);
		for (int j=1; j<=8; j++){
			GetStringFromField(cursor, 2*j+2, item_text);
			lc.SetItemText(rl_index, j, item_text);
		}
		for (j=1; j<=6; j++){
			GetStringFromAddressField(cursor, 2*j-1, item_text);
			lc.SetItemText(rl_index, j+8, item_text);
		}
	}
	error_code = IBCursorDestroy(cursor);
	if (error_code != IBERR_NONE)
		return error_code;
	error_code = IBResListDestroy(result_list);
	if (error_code != IBERR_NONE)
		return error_code;
	return IBERR_NONE;
}

// GotoCurrentFieldAddress moves the cursor to the address in the current field
// assuming the current field is of type DBADDR
void CBdeappw32Doc::GotoCurrentFieldAddress(ibcursorhandle c){
	ibdbaddr addr;
	// Get the address stored in the current field
	IBCursorFetchField(c, NULL, &addr, sizeof(ibdbaddr), NULL, NULL, NULL, NULL);
	// Move the cursor to the address
	IBCursorGotoMemberAddress(c, addr);
}

// GotoParent moves the cursor a given number of levels up in the storage graph
// and to the first field on that level
void CBdeappw32Doc::GotoParent(ibcursorhandle c, int levels) {
	// Move the cursor to the first field, which contains the address to the
	// parent record
	IBCursorGotoField(c, 0);
	// Move the cursor the requested number of levels upwards
	for (int i=0; i<levels; i++){
		GotoCurrentFieldAddress(c);
		IBCursorGotoField(c, 0);
	}
	return;
}

// GetStringFromField retrieves a string from the given field.
void CBdeappw32Doc::GetStringFromField(ibcursorhandle c, int field, CString &str) {
	struct ibdtparams params;
	wchar_t wide_buffer[300];
	TCHAR platform_buffer[300];

	// Move the cursor to field number <field>
	IBCursorGotoField(c, field);
	// Move the cursor to the record representing the tag in the current field
	GotoCurrentFieldAddress(c);
	// Move the cursor to the second field
	IBCursorGotoField(c, 1);
	// Get the the string
	params.encoding = IBENC_UTF_16LE;
#ifdef UNICODE
	IBCursorFetchField(c, NULL, platform_buffer, 300*sizeof(TCHAR),
		&params, NULL, NULL, NULL);
#else
	IBCursorFetchField(c, NULL, wide_buffer, 300*sizeof(wchar_t),
		&params, NULL, NULL, NULL);
	wcstombs(platform_buffer, wide_buffer, 300*sizeof(TCHAR));	
#endif
	str = platform_buffer;
	// Move the cursor back to the parent record
	GotoParent(c, 1);
	return;
}

// GetStringFromAddressField moves the cursor to the address field and then moves it
// down one level in the storage graph. Then it calls GetStringFromField to get a
// string from the given field and finally moves the cursor up to the previous level.
void CBdeappw32Doc::GetStringFromAddressField(ibcursorhandle c, int field, CString &str) {
	// Move the cursor to the address field
	IBCursorGotoField(c, 20);
	// Move the cursor to the record for the address tag
	GotoCurrentFieldAddress(c);
	// Get a string from tag number <field> inside the address tag record
	GetStringFromField(c, field, str);
	GotoParent(c, 1);
	return;
}

