//
// BDE demonstration application
//
// Copyright (C) 1999, 2000 by Birdstep Technology AS
//
// bdeappw32View.cpp
//
// implementation of the CBdeappw32View class
//
// Written by Henrik Solgaard
//

#include "stdafx.h"
#include "bdeappw32.h"

#include "bdeappw32View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32View

IMPLEMENT_DYNCREATE(CBdeappw32View, CListView)

BEGIN_MESSAGE_MAP(CBdeappw32View, CListView)
	//{{AFX_MSG_MAP(CBdeappw32View)
	ON_COMMAND(ID_SEARCH_COUNTRY, OnSearchCountry)
	ON_COMMAND(ID_SEARCH_FIRSTNAME, OnSearchFirstname)
	ON_COMMAND(ID_SEARCH_LASTNAME, OnSearchLastname)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_COUNTRY, OnUpdateSearchCountry)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_FIRSTNAME, OnUpdateSearchFirstname)
	ON_UPDATE_COMMAND_UI(ID_SEARCH_LASTNAME, OnUpdateSearchLastname)
	ON_COMMAND(ID_FILE_OPENDATABASE, OnFileOpendatabase)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CListView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CListView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32View construction/destruction

CBdeappw32View::CBdeappw32View()
{
	// TODO: add construction code here

}

CBdeappw32View::~CBdeappw32View()
{
}

BOOL CBdeappw32View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style = cs.style | LVS_REPORT;
	return CListView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32View drawing

void CBdeappw32View::OnDraw(CDC* pDC)
{
	// TODO: add draw code for native data here
}

void CBdeappw32View::OnInitialUpdate()
{
	CListCtrl& lc = GetListCtrl();
	CListView::OnInitialUpdate();

	lc.InsertColumn(0, _T("EntryID"), LVCFMT_LEFT, 60);
    lc.InsertColumn(1, _T("Loginname"), LVCFMT_LEFT, 120);
    lc.InsertColumn(2, _T("Password"), LVCFMT_LEFT, 120);
    lc.InsertColumn(3, _T("Lastname"), LVCFMT_LEFT, 100);
    lc.InsertColumn(4, _T("Firstname"), LVCFMT_LEFT, 100);
    lc.InsertColumn(5, _T("Date_of_Birth"), LVCFMT_LEFT, 90);
    lc.InsertColumn(6, _T("Company Name"), LVCFMT_LEFT, 150);
    lc.InsertColumn(7, _T("Salutation"), LVCFMT_LEFT, 70);
    lc.InsertColumn(8, _T("Email"), LVCFMT_LEFT, 200);
    lc.InsertColumn(9, _T("Street"), LVCFMT_LEFT, 185);
    lc.InsertColumn(10, _T("City"), LVCFMT_LEFT, 100);
    lc.InsertColumn(11, _T("Zip"), LVCFMT_LEFT, 60);
    lc.InsertColumn(12, _T("Country"), LVCFMT_LEFT, 100);
    lc.InsertColumn(13, _T("Telephone"), LVCFMT_LEFT, 100);
    lc.InsertColumn(14, _T("Fax"), LVCFMT_LEFT, 100);

}

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32View printing

BOOL CBdeappw32View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CBdeappw32View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CBdeappw32View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32View diagnostics

#ifdef _DEBUG
void CBdeappw32View::AssertValid() const
{
	CListView::AssertValid();
}

void CBdeappw32View::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}

CBdeappw32Doc* CBdeappw32View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBdeappw32Doc)));
	return (CBdeappw32Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBdeappw32View message handlers

void CBdeappw32View::OnSearchCountry() 
{
	// Get a pointer to the document object
	CBdeappw32Doc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// Get a reference to the list view control
	CListCtrl& lc = GetListCtrl();
	// Create a dialog and get the search string
	CSearchCountry Dlg;	
	CString search_string;
	if (Dlg.DoModal() == IDOK){
		search_string = Dlg.m_search_country;
		if (pDoc->SearchCountry((const char *)search_string, lc))
			MessageBox(_T("Search error"));
	}
}

void CBdeappw32View::OnSearchFirstname() 
{
	CBdeappw32Doc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CListCtrl& lc = GetListCtrl();
	CSearchFirstName Dlg;	
	CString search_string;
	if (Dlg.DoModal() == IDOK){
		search_string = Dlg.m_search_firstname;
		if (pDoc->SearchFirstName((const char *)search_string, lc))
			MessageBox(_T("Search error"));
	}
}

void CBdeappw32View::OnSearchLastname() 
{
	CBdeappw32Doc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	CListCtrl& lc = GetListCtrl();
	CSearchLastName Dlg;	
	CString search_string;
	if (Dlg.DoModal() == IDOK){
		search_string = Dlg.m_search_lastname;
		if (pDoc->SearchLastName((const char *)search_string, lc))
			MessageBox(_T("Search error"));
	}
}

// The OnUpdateXXX functions activates the search menu items when the database is opened
void CBdeappw32View::OnUpdateSearchCountry(CCmdUI* pCmdUI) 
{
	CBdeappw32Doc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->database) pCmdUI->Enable(true);
	else pCmdUI->Enable(false);	
}

void CBdeappw32View::OnUpdateSearchFirstname(CCmdUI* pCmdUI) 
{
	CBdeappw32Doc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->database) pCmdUI->Enable(true);
	else pCmdUI->Enable(false);	
}

void CBdeappw32View::OnUpdateSearchLastname(CCmdUI* pCmdUI) 
{
	CBdeappw32Doc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->database) pCmdUI->Enable(true);
	else pCmdUI->Enable(false);	
}

void CBdeappw32View::OnFileOpendatabase() 
{
	// Get a pointer to the document object
	CBdeappw32Doc *pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// Create an open file dialog
	CFileDialog Dlg (TRUE, _T("*.ice"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
				 _T("Birdstep Databases (*.ice; *.bde)|*.ice; *.bde|All Files (*.*)|*.*||"));
		if (Dlg.DoModal() == IDOK)
		// Tell the document object to open the database
		if (!pDoc->OpenDatabaseFile((LPCTSTR) Dlg.m_ofn.lpstrFile))
			MessageBox(_T("Database Opened"));
		else
			MessageBox(_T("Error opening database"));
}
